#include "IZ_app.h"

IZ_ProcedureResult IZ_InitializeApp(IZ_App* app) {
	if (SDL_Init(
		SDL_INIT_VIDEO
		| SDL_INIT_GAMECONTROLLER
		| SDL_INIT_EVENTS
	) < 0) {
		fprintf_s(stderr, "SDL could not initialize! SDL_Error: %s\n", SDL_GetError());
		return 1;
	}

	char config_path[128];
	IZ_GetConfigPath(config_path, 128);

	if (IZ_InitializeVideo(config_path, &app->video_state)) {
		return 2;
	}

	for (uint8_t p = 0; p < PLAYERS; p += 1) {
		IZ_InitializeInput(config_path, &app->input_state[p], p);
	}

	return 0;
}

void IZ_TeardownApp(IZ_App* app) {
	IZ_TeardownVideo(&app->video_state);
	SDL_Quit();
}
