#include "IZ_input.h"

void IZ_HandleInputEvents(SDL_Event e, IZ_InputState* state) {
	IZ_HandleJoystickEvents(e, &state->joystick_state, &state->action);
	IZ_HandleKeyboardEvents(e, &state->keyboard_state, &state->action);
}

void IZ_InitializeInput(const char* config_path, IZ_InputState* state, uint8_t p) {
	if (IZ_InitializeKeyboardConfig(config_path, &state->keyboard_state.config, p)) {
		fprintf_s(stderr, "Error committing keyboard config for player %d.\n", p);
	}

	if (IZ_InitializeJoystickConfig(config_path, &state->joystick_state.config, p)) {
		fprintf_s(stderr, "Error committing joystick config for player %d.\n", p);
	}

	state->action = 0;
}
