#include <SDL.h>
#include <stdbool.h>

#include "IZ_app.h"

int main(int argc, char* args[]) {
	IZ_App app;
	IZ_ProcedureResult result = IZ_InitializeApp(&app);

	if (result) {
		return result;
	}

	bool quit = false;
	SDL_Event e;
	while (true) {
		uint64_t ticks = SDL_GetTicks64();

		// TODO do audio processing
		// TODO do networking?

		// process events
		while (SDL_PollEvent(&e) != 0) {
			if (e.type == SDL_QUIT) {
				quit = true;
				break;
			}

			for (uint8_t p = 0; p < PLAYERS; p += 1) {
				IZ_HandleInputEvents(e, &(app.input_state[p]));
			}
		}

		if (quit) {
			break;
		}

		IZ_UpdateVideo(&app.video_state, &app.input_state, ticks);
	}

	IZ_TeardownApp(&app);
	return 0;
}
